#include <config.h>
#include <fft.h>

#define PII  6.283185307179586476925286766559  
float INPUT_A[N];
float dataR_A[N];//ʵ
float dataI_A[N]={0};//
float w_A[N];//ܿ 
static float sin_tab_A[N];
static float cos_tab_A[N];

float INPUT_B[N];
float dataR_B[N];//ʵ
float dataI_B[N]={0};//
float w_B[N];//ܿ 
static float sin_tab_B[N];
static float cos_tab_B[N];

void InitForFFT_A(void)
{
  unsigned int i;
	for ( i=0;i<N;i++ )
	{
		sin_tab_A[i]=sin(PII*i/N);
		cos_tab_A[i]=cos(PII*i/N);
	}
}

void InitForFFT_B(void)
{
  unsigned int i;
	for ( i=0;i<N;i++ )
	{
		sin_tab_B[i]=sin(PII*i/N);
		cos_tab_B[i]=cos(PII*i/N);
	}
}

void FFT_A(void)
{
	unsigned int x0,x1,x2,x3,x4,x5,x6,xx=0;
	unsigned int i,j,k,b,p,L;
	float TR,TI,temp;
	float avg_w_value = 0;
	
	for (i=0;i<N;i++)
	{
		dataR_A[i]=(float)INPUT_A[i];
		dataI_A[i]=0.0f;                 
		w_A[i]=0;
	}	
/********** following code invert sequence ************/
	for ( i=0;i<N;i++ )
	{
		x0=x1=x2=x3=x4=x5=x6=0;
		x0=i&0x01; x1=(i/2)&0x01; x2=(i/4)&0x01; x3=(i/8)&0x01;x4=(i/16)&0x01; x5=(i/32)&0x01; x6=(i/64)&0x01; 
		xx=x0*64+x1*32+x2*16+x3*8+x4*4+x5*2+x6;
		dataI_A[xx]=dataR_A[i];
	}
	for ( i=0;i<N;i++ )
	{
		dataR_A[i]=dataI_A[i]; dataI_A[i]=0;   
	}

/************** following code FFT *******************/
	for ( L=1;L<=7;L++ )         
	{
		b=1; i=L-1;
		while ( i>0 )
		{
			b=b*2; i--;
		} 
		for ( j=0;j<=b-1;j++ ) 
		{
			p=1; i=7-L;   
			while ( i>0 ) 
			{
				p=p*2; i--;
			}
			p=p*j;
			for ( k=j;k<N;k=k+2*b ) 
			{
				TR=dataR_A[k]; TI=dataI_A[k]; temp=dataR_A[k+b];
				dataR_A[k]=dataR_A[k]+dataR_A[k+b]*cos_tab_A[p]+dataI_A[k+b]*sin_tab_A[p];
				dataI_A[k]=dataI_A[k]-dataR_A[k+b]*sin_tab_A[p]+dataI_A[k+b]*cos_tab_A[p];
				dataR_A[k+b]=TR-dataR_A[k+b]*cos_tab_A[p]-dataI_A[k+b]*sin_tab_A[p];
				dataI_A[k+b]=TI+temp*sin_tab_A[p]-dataI_A[k+b]*cos_tab_A[p];
			} 
		} 
	} 

	for ( i=0;i<N/2;i++ ){
		w_A[i]= sqrt(dataR_A[i]*dataR_A[i]+dataI_A[i]*dataI_A[i]);
	}
}

void FFT_B(void)
{
	unsigned int x0,x1,x2,x3,x4,x5,x6,xx=0;
	unsigned int i,j,k,b,p,L;
	float TR,TI,temp;
	float avg_w_value = 0;
	
	for ( i=0;i<N;i++ )
	{
		dataR_B[i]=(float)INPUT_B[i];
		dataI_B[i]=0.0f;                 
		w_B[i]=0;
	}	
/********** following code invert sequence ************/
	for ( i=0;i<N;i++ )
	{
		x0=x1=x2=x3=x4=x5=x6=0;
		x0=i&0x01; x1=(i/2)&0x01; x2=(i/4)&0x01; x3=(i/8)&0x01;x4=(i/16)&0x01; x5=(i/32)&0x01; x6=(i/64)&0x01; 
		xx=x0*64+x1*32+x2*16+x3*8+x4*4+x5*2+x6;
		dataI_B[xx]=dataR_B[i];
	}
	for ( i=0;i<N;i++ )
	{
		dataR_B[i]=dataI_B[i]; dataI_B[i]=0;   
	}

/************** following code FFT *******************/
	for ( L=1;L<=7;L++ )         
	{
		b=1; i=L-1;
		while ( i>0 )
		{
			b=b*2; i--;
		} 
		for ( j=0;j<=b-1;j++ ) 
		{
			p=1; i=7-L;   
			while ( i>0 ) 
			{
				p=p*2; i--;
			}
			p=p*j;
			for ( k=j;k<N;k=k+2*b ) 
			{
				TR=dataR_B[k]; TI=dataI_B[k]; temp=dataR_B[k+b];
				dataR_B[k]=dataR_B[k]+dataR_B[k+b]*cos_tab_B[p]+dataI_B[k+b]*sin_tab_B[p];
				dataI_B[k]=dataI_B[k]-dataR_B[k+b]*sin_tab_B[p]+dataI_B[k+b]*cos_tab_B[p];
				dataR_B[k+b]=TR-dataR_B[k+b]*cos_tab_B[p]-dataI_B[k+b]*sin_tab_B[p];
				dataI_B[k+b]=TI+temp*sin_tab_B[p]-dataI_B[k+b]*cos_tab_B[p];
			} 
		} 
	} 

	for ( i=0;i<N/2;i++ ){
		w_B[i]= sqrt(dataR_B[i]*dataR_B[i]+dataI_B[i]*dataI_B[i]);
	}
}